#
# step1.rb
#
# $Id: step1.rb,v 1.1 2000/11/21 03:15:29 keiko Exp $
#

require "num/numarray"
require "num/dcl"

include Num::DCL
include Math


NMAX = 201
IMAX = 5
LEN_2 = 5

X  = 0
Y0 = 1
Y1 = 2
Y2 = 3
Y3 = 4

z1 = NumArray.new(Float, NMAX, LEN_2)
# 2nd Dimension
#    0: X, 1: Y0, 2: Y1, 3:Y2 4: Y3    in step1.f

a = []

#-- data ----
for m in 1..IMAX
  tm = (2*m - 1)*PI
  a[m-1] = (-1)**m * 2/tm
end

for n in 1..NMAX
  z1[n-1,X] = 1.0*(n-1)/(NMAX-1)
  tn = 2*PI*z1[n-1,X]

  z1[n-1,Y0] =
    if (tn < PI/2 || tn >= PI*3/2) then 0.0 else 1.0 end
  z1[n-1,Y1] = 0.5 + a[0]*cos(tn)
  z1[n-1,Y2] = 0.5
  z1[n-1,Y3] = 0.5

  for k in 1..IMAX
    tk = 2*k - 1
    tc = a[k-1]*cos(tk*tn)

    z1[n-1,Y2] = z1[n-1,Y2] +
      if (k <= 3) then tc else 0 end
    z1[n-1,Y3] = z1[n-1,Y3] + tc
  end
end

#-- graph ----
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws
grfrm

x  = z1[true,X]
y0 = z1[true,Y0]
y1 = z1[true,Y1]
y2 = z1[true,Y2]
y3 = z1[true,Y3]

usspnt(NMAX, x, y0)
usspnt(NMAX, x, y1)
usspnt(NMAX, x, y2)
usspnt(NMAX, x, y3)

uspfit
grstrf

ussttl('FREQUENCY', '/DAY', 'RESPONSE', '')
usdaxs

uulin(NMAX, x, y0)

uuslnt(2)
uuslni(3)
uulin(NMAX, x, y1)

uuslnt(3)
uulin(NMAX, x, y2)

uuslnt(4)
uulin(NMAX, x, y3)

grcls

