#
# u2d6.rb
#
# $Id: u2d6.rb,v 1.1 2000/11/21 03:15:45 keiko Exp $
#

require "num/numarray"
require "num/dcl"

include Num::DCL
include Math


NX = 11
NY = 11
XMIN = -1
XMAX = 1
YMIN = -1
YMAX = 1
u = NumArray.new(Float, NX, NY)
v = NumArray.new(Float, NX, NY)

#-- data ---
for j in 0..NY-1
  for i in 0..NX-1
    x = XMIN + (XMAX-XMIN)*i/(NX-1).to_f
    y = YMIN + (YMAX-YMIN)*j/(NY-1).to_f
    u[i,j] =  x * 0.1
    v[i,j] = -y
  end
end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

grfrm

grswnd(XMIN, XMAX, YMIN, YMAX)
grsvpt(0.2, 0.8, 0.2, 0.8)
grstrn(1)
grstrf

usdaxs

uglset('LNRMAL', false)
ugrset('XFACT1', 0.5)
ugrset('YFACT1', 0.05)
uglset('LUNIT', true)
ugrset('VXUNIT', 0.1)
ugrset('VYUNIT', 0.1)
ugrset('VXUOFF', 0.06)
ugsut('X', 'U')
ugsut('Y', 'V')
ugvect(u, NX, v, NX, NX, NY)

grcls

